<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Relations\BelongsTo;

class LlmMessage extends Model
{
    use HasFactory;

    protected $table = 'llm_messages';

    protected $fillable = [
        'session_id',
        'role',
        'content',
        'reasoning_content',
        'metadata',
    ];

    protected $casts = [
        'metadata' => 'array',
    ];

    public function session(): BelongsTo
    {
        return $this->belongsTo(LlmSession::class, 'session_id');
    }
}