<?php

namespace App\Services\File;

use App\Libraries\BIM\BIMDriverEnum;
use App\Models\Enums\ActionObjectType;
use App\Models\Enums\BimFileConvertStatus;
use App\Models\Enums\FileObjectType;
use App\Models\Enums\ObjectAction;
use App\Models\File;
use App\Repositories\ActionRepository;
use App\Repositories\CustomFieldRepository;
use App\Services\History\ModelChangeDetector;
use Illuminate\Support\Facades\Auth;

class FileService
{
    private CustomFieldRepository $customFieldRepository;
    public function __construct(CustomFieldRepository $customFieldRepository)
    {
        $this->customFieldRepository = $customFieldRepository;
    }

    public function update(string $id, array $updatedData): void
    {
        $file = File::query()->findOrFail($id);
        $updatedData['updated_by'] = Auth::user()->id;
        $file->fill($updatedData);

        $changes = ModelChangeDetector::detector(ActionObjectType::CONTAINER_FILE, $file);
        ActionRepository::create($id, ActionObjectType::CONTAINER_FILE, ObjectAction::EDITED_FILE, null, null, [], $changes);

        $file->save();
    }
}
